import java.applet.Applet;
import java.io.IOException;
import java.io.OutputStream;
import java.io.StringWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import quadbase.common.param.CssHtmlParameterPageWriter;
import quadbase.common.param.ParameterPage;
import quadbase.reportdesigner.ReportAPI.QbReport;


public class CSSParamPage extends HttpServlet{
	static final long serialVersionUID = 1; 	
	public void doGet(HttpServletRequest req, HttpServletResponse res) 
	throws ServletException, IOException {

		res.setContentType("text/html");
		OutputStream toClient = res.getOutputStream();
		try {
			// Do not connect to EspressManager
			QbReport.setEspressManagerUsed(false);
			String reportLocation = "CssParamPage.pak";

			// Create the ObReport object using back-up data
			QbReport report = new QbReport((Applet)null, reportLocation, false, false, false, true, false);

			// Specify the parameters for connecting to ParamReportGeneratorServlet
			report.setDynamicExport(true, "127.0.0.1", 8080);

			// Specify report template location and desired export format
			ParameterPage paramPage = report.getParameterPage(reportLocation, null, QbReport.DHTML, null);
			// Writer writer = new PrintWriter(toClient);

			StringWriter tempStringWriter = new StringWriter();

			CssHtmlParameterPageWriter cssParamPageWriter = new CssHtmlParameterPageWriter(paramPage, tempStringWriter);

			// Specify the css file to be used
			cssParamPageWriter.setCssFile("http://localhost:8080/CssExample.css");

			// Create head of html page, adding title and css specification
			cssParamPageWriter.write("<HEAD>\n" +
					"<link REL=\"stylesheet\" TYPE=\"text/css\" " +
					"href=\"" + cssParamPageWriter.getCssFile() + "\">" +
					"\n<TITLE></TITLE>\n" +	"</HEAD>");

			// Body section - Most of the formatting is done in the css file, very little is needed here
			cssParamPageWriter.write("\n<body><p>&nbsp;</p>");
			
			// Add title and fieldset
			cssParamPageWriter.write("<TABLE class=\"outer\"><TR><TD><p class=\"heading2\">" +
					"Welcome to the Order History Database." +
			"</TD></TR><TR><TD>&nbsp;</TD></TR><TR><TD><FIELDSET><LEGEND>Select</LEGEND>");
			// Add the parameter forms 
			cssParamPageWriter.writeBodyBody();

			// Finish it off
			cssParamPageWriter.write("</FIELDSET></TD></TR></TABLE></body>\n</html>");

			String paramHTMLPage = tempStringWriter.toString();

			toClient.write(paramHTMLPage.getBytes());
					
		} catch(Exception e) {
			e.printStackTrace();
		}

		toClient.flush();
		toClient.close();
	}
}
